﻿using System;
using System.Windows.Forms;
using System.Reflection;

namespace ExtensibleObjectProperties
{
	public partial class Form1 : Form
	{
		protected xObject		m_object	= new xObject();

		public Form1()
		{
			InitializeComponent();
		}

		private void Display_xBuiltinProperties()
		{
			ListViewItem	lv_item;

			listView_properties.Items.Clear();

			foreach (PropertyInfo pinfo in m_object.xProperties.BuiltinProperties)
			{
				lv_item = new ListViewItem(pinfo.Name);

				lv_item.SubItems.Add(pinfo.GetValue( m_object, null).ToString());
				lv_item.Tag = pinfo;

				listView_properties.Items.Add(lv_item);
			}
		}


		private void Display_ObjProperties()
		{
			ListViewItem	lv_item;

			listView_all_properties.Items.Clear();

			Type	obj_class	= typeof( xObject);
			PropertyInfo[]	properties	= obj_class.GetProperties();
			PropertyInfo	property;

			for (int ndx = 0; ndx < properties.Length; ndx++)
			{
				property	= properties[ndx];

				lv_item	= new ListViewItem(property.Name);

				lv_item.SubItems.Add( property.GetValue( m_object, null).ToString());
				lv_item.Tag	= property;

				listView_all_properties.Items.Add(lv_item);
			}
		}


		private void Form1_Load(object sender, EventArgs e)
		{
			Display_xBuiltinProperties();
			Display_ObjProperties();
		}

		private ListViewItem CurrentItem
		{
			get
			{
				if( listView_properties == null)
					return null;
				return listView_properties.FocusedItem;
			}
		}

		private PropertyInfo CurrentProperty
		{
			get
			{
				ListViewItem	lv_item	= CurrentItem;
				if( lv_item == null)
					return null;

				return (PropertyInfo) lv_item.Tag;
			}
		}


		private void listView_properties_SelectedIndexChanged(object sender, EventArgs e)
		{
			PropertyInfo	property	= CurrentProperty;

			if( property == null)
				return;

			textBox_property_value.Text	= property.GetValue( m_object, null).ToString();
		}

		private void button1_Click(object sender, EventArgs e)
		{
			PropertyInfo		property	= CurrentProperty;

			if (property == null)
				return;

			int		current_item_index	= listView_properties.FocusedItem.Index;

			if( m_object.xProperties.BuiltinProperties.SetValue( m_object, property, textBox_property_value.Text) == false)
			{
				MessageBox.Show("Cannot convert textbox value to this property");
				return;
			}


			Display_xBuiltinProperties();
			Display_ObjProperties();

			// reselect the old selected item
			listView_properties.Items[current_item_index].Selected	= true;
			listView_properties.FocusedItem	= listView_properties.Items[current_item_index];
		}
	}
}
