﻿using System;

namespace ExtensibleObjectProperties
{
	/// <summary>
	/// This an attribute class.
	/// An attribute has a name and data type.
	/// It provides helper methods to assign a value of this data type to a property.
	/// </summary>
	public class xAttribute
	{
		protected string	m_name				= "";
		protected Type		m_data_type			= typeof( int);
	
		
		public xAttribute()
		{
		}

		public xAttribute(string name, Type data_type)
		{
			m_name			= name;
			m_data_type		= data_type;
		}

		public string Name
		{
			get { return m_name; }
			set
			{
				if( string.IsNullOrEmpty( value))
					return;
				m_name = value;
			}
		}

		public Type Data_type
		{
			get { return m_data_type; }
			set
			{
				if( value == null)
					return;
				m_data_type = value;
			}
		}


		/// <summary>
		/// Can we convert the given value?
		/// </summary>
		/// <param name="obj_value">The value to test</param>
		/// <returns>true if conversion can be done, false otherwise</returns>
		public bool CanConvertValue( object obj_value)
		{
			if (obj_value == null || m_data_type == null)
				return true;

			try
			{
				Convert.ChangeType(obj_value, m_data_type);
			}
			catch (InvalidCastException)	//castex)
			{
				return false;
			}
			catch (Exception)				// ex)
			{
				return false;
			}
			return true;
		}


	}
}
