﻿using System.Collections.Generic;
using System.Reflection;

namespace ExtensibleObjectProperties
{
	public class xPropertyList: List<xProperty>
	{
		xObject		m_object		= null;
		//protected xBuiltinPropertiesListBase<PropertyInfo, xObject, xSysPropertyAttribute>	
		//        m_builtin_properties
		//                    = new xBuiltinPropertiesListBase<PropertyInfo,xObject,xSysPropertyAttribute>();

		protected xBuiltinProperties m_builtin_properties = new xBuiltinProperties();

		public xPropertyList(xObject obj)
		{
			m_object	= obj;
		}

		public //xBuiltinPropertiesListBase<PropertyInfo, xObject, xSysPropertyAttribute> 
			xBuiltinProperties	BuiltinProperties
		{
			get { return m_builtin_properties; }
		}

		public xProperty this[string attribute_name]
		{
			get
			{
				if( Count <= 0 ||string.IsNullOrEmpty( attribute_name))
					return null;

				foreach (xProperty p in this)
				{
					if( p.Attribute == null)
						continue;

					if( string.Compare( p.Attribute.Name, attribute_name, true) == 0)
						return p;
				}
				return null;
			}
		}


		public bool SetBuiltinPropertyValue(PropertyInfo sys_property, object obj_value)
		{
			if( sys_property == null)
				return false;

			return SetBuiltinPropertyValue( sys_property.Name, obj_value);
		}


		public bool SetBuiltinPropertyValue(string property_name, object obj_value)
		{
			return m_builtin_properties.SetValue( m_object, property_name, obj_value);
		}



		public bool SetValue(string attrib_name, object obj_value)
		{
			if( string.IsNullOrEmpty( attrib_name))
				return false;

			xProperty	property	= this[attrib_name];

			// if teh property not found: add a new attribute with the given name
			// assign it in a new property
			if (property == null)
			{
				if( obj_value == null)
					return false;

				xAttribute	attrib	=new xAttribute( attrib_name, obj_value.GetType());
				property	= new xProperty( attrib, obj_value);

				Add(property);
				return true;
			}

			property.Value	= obj_value;
			return true;
		}

	}
}
